// Copyright (C) 2024  AstroGD® Lukas Weber
import { assert } from "console";

export function v(x: number, y: number, w: number): number {
  assert(1 <= x && x <= 9);
  assert(1 <= y && y <= 9);
  assert(1 <= w && w <= 9);

  return x + 9 * (y - 1) + 81 * (w - 1);
}

export function getXYW(v: number): { x: number; y: number; w: number } {
  assert(1 <= v && v <= 729);

  const w = Math.floor((v - 1) / 81) + 1;
  const y = (Math.floor((v - 1) / 9) % 9) + 1;
  const x = ((v - 1) % 9) + 1;

  return { x, y, w };
}

export type N = 1 | 2 | 3 | 4 | 5 | 6 | 7 | 8 | 9;
